﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Seminar04_Mi
{
    abstract class Artikel // ein Posten im Katalog
    {
        uint bestellnummer;
        static uint letzteVergebeneBestellnummer;
        string titel;
        uint anzahlAmLager;
        uint preisInCent;

        public Artikel(string titel, uint anzahlAmLager, uint preisInCent)
        {
            letzteVergebeneBestellnummer++;
            bestellnummer = letzteVergebeneBestellnummer;
            this.titel = titel;
            this.anzahlAmLager = anzahlAmLager;
            this.preisInCent = preisInCent;
        }
    }

    class Buch : Artikel
    {
        string autor;
        string isbn;
        uint seitenzahl;

        public Buch(string titel, uint anzahlAmLager, uint preisInCent, string autor, string isbn, uint seitenzahl)
        : base(titel, anzahlAmLager, preisInCent)
        {
            this.autor = autor;
            this.isbn = isbn;
            this.seitenzahl = seitenzahl;
        }
    }

    class DVD : Artikel
    {
        TimeSpan spieldauer;

        public DVD(string titel, uint anzahlAmLager, uint preisInCent, TimeSpan spieldauer)
        : base(titel, anzahlAmLager, preisInCent)
        {
            this.spieldauer = spieldauer;
        }
    }

    class BluRayDisc : Artikel
    {
        public BluRayDisc(string titel, uint anzahlAmLager, uint preisInCent)
        : base(titel, anzahlAmLager, preisInCent)
        {
        }
    }

    class Kunde
    {
        string nachname;
        string vorname;
        string wohnort;
        uint postleitzahl;
        string straßeUndHausnummer;
    }

    class Bestellung
    {
        Kunde kunde;
        List<Position> warenkorb = new List<Position>();
        class Position
        {
            Artikel artikel;
            uint anzahl;

            public Position(Artikel artikel, uint anzahl)
            {
                this.artikel = artikel;
                this.anzahl = anzahl;
            }

            public Artikel Artikel { get { return artikel; } }
        }

        public Bestellung(Kunde kunde)
        {
            this.kunde = kunde;
        }

        public void FügeHinzu(Artikel artikel, uint anzahl)
        {
            int i = warenkorb.FindIndex(x => x.Artikel == artikel);
            //TODO: Wenn schon vorhanden (i >= 0), dann nicht neu hinzufügen, sondern die Anzahl ändern
            warenkorb.Add(new Position(artikel, anzahl));
        }

    }
}
